Bug 434800 - xenkbd can crash when probe fails
xenkbd can crash when probe fails
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel-xen (Show other bugs)
5.1
All Linux
medium Severity medium
: rc
: ---
Assigned To: Markus Armbruster
Martin Jenner
:
: 434802 434806 451807 (view as bug list)
Depends On: 434802
Blocks: 448753 496206
  Show dependency treegraph
 
Reported: 2008-02-25 11:18 EST by Markus Armbruster
Modified: 2009-04-17 05:17 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 496206 (view as bug list)
Environment:
Last Closed: 2009-01-20 15:07:17 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Markus Armbruster 2008-02-25 11:18:41 EST
Description of problem:
When xenkbd_probe() fails, it calls xenkbd_remove() to clean up.  

If it fails before the input device successfully registered, info->dev is still
null, and xenkbd_remove() must not call input_unregister_device() for it.

If it fails before info->irq gets its real value, xenkbd_resume() calls
unbind_from_irqhandler() for irq 0 when it should do nothing

How reproducible:
Haven't tried.
Comment 1 Markus Armbruster 2008-02-26 09:29:54 EST
The most likely trigger is when there's not enough memory for the new device. 
Not too likely, especially because the device is compiled in and thus probes
fairly early.

When the bug bites, the driver dereferences a null pointer during cleanup from a
failed probe.
Comment 2 Markus Armbruster 2008-02-26 10:12:08 EST
See bug 434802 for a proposed fix.
Comment 3 RHEL Product and Program Management 2008-06-09 17:58:47 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 5 Don Zickus 2008-07-18 16:06:57 EDT
in kernel-2.6.18-98.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 6 Markus Armbruster 2008-07-21 12:43:13 EDT
*** Bug 451807 has been marked as a duplicate of this bug. ***
Comment 7 Markus Armbruster 2008-07-21 12:43:53 EDT
*** Bug 434806 has been marked as a duplicate of this bug. ***
Comment 8 Markus Armbruster 2008-07-21 12:45:39 EDT
*** Bug 434802 has been marked as a duplicate of this bug. ***
Comment 11 errata-xmlrpc 2009-01-20 15:07:17 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html

Note You need to log in before you can comment on or make changes to this bug.